#ifndef SUDOKU_H
#define SUDOKU_H
#include "types.h"
#include "movements.h"
namespace sudoku {

class Sudoku
{
public:
    Sudoku(const Matrix & mat);
    bool solve();

private:
void fill(const Move&m);
    void init();

    void unfill(const Move &m);


    MovementsPtr moves_;
    QueueMoves sol_;

    const Matrix &mat_;
};

using OptSudoku=std::experimental::optional<Sudoku>;
}
#endif // SUDOKU_H
