#ifndef TYPES_H
#define TYPES_H
#include <vector>
#include <map>
#include <deque>
#include <experimental/optional>

namespace sudoku {
constexpr int N = 9;
using IntType = int;


using Matrix = IntType[N][N];
using VctIntType=std::vector<IntType>;

struct Pos{
    Pos(IntType row,IntType col):row(row),col(col)
    {

    }

    IntType row,col;
};

struct Move
{
    Move(const Pos&p,IntType v):pos(p),val(v)
    {

    }
    Pos pos;
    IntType val;

};


using MapMoves=std::map<Pos,VctIntType>;
using QueueMoves=std::deque<Move>;
using VctMoves=std::vector<Move>;
using OptMoves=std::experimental::optional<Move>;
}
#endif // TYPES_H
