#include "validation.h"
#include <algorithm>
namespace sudoku {



validation::validation(const sudoku::Matrix &mat):mat_(mat)
{

}

bool validation::valid() const
{
     if (false==validRows())
         return false;
     if (false==validCols())
         return false;
     if (false==validSubmatrices())
         return false;

     return true;
}

bool validation::complete() const
{
for(auto i=0;i < N ;i++)
    for(auto j=0;j < N ;j++)
        if(mat_[i][j]==0)
            return false;

 return true;
}
bool validation::validRows() const
{
for (auto i=0; i< N ;i++)
    if (false==isValidRow(i))
        return false;

return true;
}

bool validation::validCols() const
{
    for (auto i=0; i< N ;i++)
        if (false==isValidCol(i))
            return false;

    return true;
}

bool validation::validSubmatrices() const
{
    for (auto i=0; i< N ;i++)
        if (false==isValidSubMatrix(i))
            return false;

    return true;
}

bool validation::isValidVct( VctIntType &v) const
{
    std::sort(begin(v),end(v),
              [](auto & a, auto &b)->bool
    {
                  return a < b;
    });

    auto it = std::unique(v.begin(),v.end(),
                          [](auto & a, auto &b)->bool
    {
                  return a == b;
    });

    if (it==v.end())
        return true;
    else
        return false;

}

bool validation::isValidRow(IntType row) const
{
    VctIntType vct;
    for (auto i=0; i< N ;i++)
    {
    if (mat_[row][i])
        vct.emplace_back(mat_[row][i]);
    }
    return isValidVct(vct);
}

bool validation::isValidCol(IntType col) const
{
    VctIntType vct;
    for (auto i=0; i< N ;i++)
    {
    if (mat_[i][col])
        vct.emplace_back(mat_[i][col]);
    }
    return isValidVct(vct);
}

VctIntType validation::getSubMatrix(int idx) const
{
    auto row = idx/3;
    auto col = idx%3;
    VctIntType vct;
    for (auto i=row;i< row + 3 ;i++)
        for (auto j=col;j< col + 3 ;j++)
            if (mat_[i][j])
                vct.emplace_back(mat_[i][j]);
    return vct;
}

bool validation::isValidSubMatrix(int i) const
{
    auto vct=getSubMatrix(i);
    return isValidVct(vct);
}



}
