#ifndef VALIDATION_H
#define VALIDATION_H
#include "types.h"
namespace sudoku{


class validation
{
public:
    validation(const Matrix &mat);
    bool valid() const;
    bool complete() const;
private:
    bool isValidVct( VctIntType &v) const;
    bool isValidRow(IntType row) const;


    bool isValidCol(IntType col) const;
    VctIntType getSubMatrix(int i) const;
    bool isValidSubMatrix(int i) const;

    bool validRows() const;
    bool validCols() const;
    bool validSubmatrices() const;
    const Matrix &mat_;

};
}
#endif // VALIDATION_H
