#include <iostream>
#include <dds/pub/ddspub.hpp>
#include <rti/util/util.hpp> // for sleep()
#include "Foo.hpp"
#include "WriterWithProfile.h"
#include "WriterCustomQoS.h"
#include "topicnames.h"
#include <dds/core/QosProvider.hpp>
using namespace easydds;


void easyPub()
{

    auto cfg=std::make_unique<config>("/usr/local/pkg/rti_connext_dds-5.2.0/resource/xml/NDDS_QOS_PROFILES.example.xml","UserQosProfilesLibrary::User.Generic.Common",0);
    auto dc=std::make_unique<DomainContext>(cfg);

    //auto wr=WriterBestEffort<MyOtherType>(dc,TopicNames::topic1);
    auto wr2=customQoS::WriterMyStrictReliable<MyOtherType>(dc,TopicNames::topic2);


    int count=0;
    MyOtherType sample;
    sample.m3("Hello easydds");
    for (;;)
    {
        std::cout << "Writting MyOtherType, count " << count << std::endl;
        sample.m1(count++);
//        wr.publish(sample);

//        sample.m1(count*2);
        wr2.publish(sample);
        rti::util::sleep(dds::core::Duration(1));
    }
}

void publisher_main(int domain_id, int sample_count)
{


// Create a DomainParticipant with default Qos
dds::domain::DomainParticipant participant (domain_id);
// Create a Topic -- and automatically register the type
dds::topic::Topic<MyOtherType> topic (participant, "Example MyOtherType");
// Create a DataWriter with default Qos (Publisher created in-line)
dds::pub::DataWriter<MyOtherType> writer(dds::pub::Publisher(participant), topic);
MyOtherType sample;
sample.m3("Hello");
for (int count = 0; count < sample_count || sample_count == 0; count++) {
// Modify the data to be written here
std::cout << "Writting MyOtherType, count " << count << std::endl;
sample.m1(count);
writer.write(sample);
rti::util::sleep(dds::core::Duration(4));
}
}
int main(int argc, char *argv[])
{


int domain_id = 0;
int sample_count = 0; // infinite loop
if (argc >= 2) {
domain_id = atoi(argv[1]);
}
if (argc >= 3) {
sample_count = atoi(argv[2]);
}
// To turn on additional logging, include <rti/config/Logger.hpp> and
// uncomment the following line:
// rti::config::Logger::instance().verbosity(rti::config::Verbosity::STATUS_ALL);
try {
//publisher_main(domain_id, sample_count);
    easyPub();
} catch (const std::exception& ex) {
// This will catch DDS exceptions
std::cerr << "Exception in publisher_main(): " << ex.what() << std::endl;
return -1;
}
// RTI Connext provides a finalize_participant_factory() method
// if you want to release memory used by the participant factory singleton.
// Uncomment the following line to release the singleton:
//
// dds::domain::DomainParticipant::finalize_participant_factory();
return 0;
}
