#ifndef WRITER_H
#define WRITER_H

#include "domaincontext.h"
#include "entityconfig.h"
#include <iostream>
namespace easydds {
template <typename T> class writer
{

public:
    using TopicType=dds::topic::Topic<T>;
    using TopicPtr = std::unique_ptr<TopicType> ;

    using DataWriterType=dds::pub::DataWriter<T>;
    using DataWriterPtr=std::unique_ptr<DataWriterType>;

    writer(const DomainContextPtr &dc,const DataWriterConfig &wrCfg)
    {
        topic_      = std::make_unique<TopicType>(dc->domainParticipant(),wrCfg.topic);

        (*dc->getQosProvider())->default_library(wrCfg.library);
        dds::pub::qos::DataWriterQos wrQoS=dc->getQosProvider()->datawriter_qos(wrCfg.profile);

        dataWriter_ = std::make_unique<DataWriterType>(dc->publisher(),*topic_.get(),wrQoS);
    }

    void publish(const T & sample)
    {
        dataWriter_->write(sample);
    }

private:
    TopicPtr topic_;
    DataWriterPtr dataWriter_;
};
}
#endif // WRITER_H
